/*	Processing logic signals at the inputs of the microcontroller.
Author:
 ,  2011
Gennady Chernov, Dnipropetrovsk 2011
The version v2.0.
Email: gena.chernov@gmail.com
http://svetomuzyka.narod.ru/
*/

#include <htc.h>			// Standard title of the description 
#include "indic_4led.h"		// Control of indication


// Controler PIC16F886, clocking - internal the generator with frequency 8 MHz.
// MPLAB v8.76, HI-TECH C for the PIC10/12/16 MCU Family v.9.83
//---------------------------------------------------------------------------
// Controler configuring
__CONFIG(
 FOSC_INTRC_NOCLKOUT & 	//Generator choice, the Internal generator, port function on RA6 and RA7
 WDTE_ON &				//WDT enabled
 PWRTE_ON &				//PWRT enabled
 MCLRE_ON & 			//RE3/MCLR pin function is MCLR
 CP_ON &				//Data memory code protection is enabled
 DEBUG_OFF & 			//In-Circuit Debugger disabled
 LVP_OFF & 				//RB3 pin has digital I/O, HV on MCLR must be used for programming
 FCMEN_OFF & 			//Fail-Safe Clock Monitor is disabled
 IESO_OFF & 			//Internal/External Switchover mode is disabled
 BOREN_ON &				//Reset on supply reduction is included
 CPD_ON & 				//Protection of code EEPROM is included
 WRT_OFF & 				//Record protection in storage of programs is disconnected
 BOR4V_BOR21V);			//Level of pressure of actuating reset at reduction of a supply 2.1 In
//---------------------------------------------------------------------------


// Determinations for prototypes of functions
void init(void);			//Controler initialization
void Klava (void);			//Handling of pushing of buttons
void portcon(void);			//Inquiry of the keypad and signals of remote sensors



volatile bit te00,te01,te02,te03,te04,te05,te06,te07,
BU00,BU01,BU02,BU03,BU04,BU05,BU06,BU07;	// Status bits of inputs and the button
volatile char tiBR00,tiBR01,tiBR02,tiBR03,
tiBR04,tiBR05,tiBR06,tiBR07,				//Timers of filters
rPORTB; 									//The buffer register

bit KLNAJ;	//flag  The button is pushed
bit PEREK;  //Flag a mode of switching of indication	

//--------------------------------------------------------------------
// Timers of the program of autodial
char timer_avt,timer_avtper;
//--------------------------------------------------------------------

volatile char  timer_uderj;	// The filter of holding of buttons

char perem; //



// The demonstration program 
//--------------------------------------------------------------------
void main(void)
{
//--------------------------------------------------------------------
	NOP(); 						//
	CLRWDT(); 					//Reset of the Watchdog Timer +++++++++++++++++++++- 
	init();						//Controler initialization
	perem=33;
	__delay_ms(20);				// "" 
//====================================================================
	// Program basis cycle
while(1)
	{
		CLRWDT(); 			// Reset of the Watchdog Timer  +++++++++++++++++++++- 
		portcon(); 			// Control of ports and buttons
		Klava (); 			// Handling of pushing of buttons


		if(PEREK==0)
		{
			bin_dec (perem,0,0);
			zagin(tysc,sotn,dest,edin);
		}
		else
		{
			if(BU04==0)tysc=co;
			else tysc=ci;
			if(BU05==0)sotn=co;
			else sotn=ci;
			if(BU06==0)dest=co;
			else dest=ci;
			if(BU07==0)edin=co;
			else edin=ci;
			zagin(tysc,sotn,dest,edin);			
		}		 

	}
	
}//end programm==========================================================









// Handling of pushing of buttons
void Klava (void)
{

//--------------------------------------------------------------------
		if(BU00)//  Button click 1
		{
			if(!KLNAJ)	//We test - the button is not pushed yet?
			{
				KLNAJ=1; // The button is pushed
	// Here handling of button click 1
				perem--;
			}
		}
//--------------------------------------------------------------------
		else
		if(BU01)// Button click 2
		{
			if(!KLNAJ)	//We test - the button is not pushed yet?
			{
				KLNAJ=1; // The button is pushed				
	// Here handling of button click 2
				perem++;
			}			
		}
//--------------------------------------------------------------------
		else
		if(BU02)// Button click 3
		{
			if(!KLNAJ)	//We test - the button is not pushed yet?
			{
				KLNAJ=1; 		// The button is pushed
	// Here handling of button click 3
				perem=20;
			}
		}						
//--------------------------------------------------------------------
		else
		if(BU03)// Button click 4
		{
			if(!KLNAJ)			//We test - the button is not pushed yet?
			{
				KLNAJ=1; 		// The button is pushed
	// Here handling of button click 4
				PEREK=!PEREK; // Switchings of a type of indication	
			}	
		}
//--------------------------------------------------------------------
		else
		{
		//   
			KLNAJ=0;			//   
			timer_avt=250;		//    
			timer_avtper = 150;	//   
		}
//--------------------------------------------------------------------
		// In this place handling of pushing of several keys or holding

//--------------------------------------------------------------------
		//Key press auto-repeat
		if (timer_avt==0)
		{
			KLNAJ=0; //      	 +------   
			if (timer_avtper != 10)--timer_avtper; //   
			timer_avt=timer_avtper; //   
		}								
}//--------------------------------------------------------------------		













//Inquiry of the keypad and signals of remote sensors	
void portcon(void)	
{
#define ZADKLAV 1 // Time delay on pushing of buttons of the keypad
#define ZADINPU 20 // Time delay on control of signals of remote sensors
//--------------------------------------------------------------------
// Testing of signals of remote sensors
			if(rPORTB & 0b10000000)// We test an input for low level
			{
				if(te07==1)	
				{
					te07=0;
					tiBR07=ZADINPU;
				}
				if(tiBR07==0)BU07=1;
			}
			else
			{
				if(te07==0)	
				{
					te07=1;
					tiBR07=ZADINPU;
				}
				if(tiBR07==0)BU07=0;
			}		
//-------------------------------------------------------
			if(rPORTB & 0b01000000)// We test an input for low level
			{
				if(te06==1)	
				{
					te06=0;
					tiBR06=ZADINPU;
				}
				if(tiBR06==0)BU06=1;
			}
			else
			{
				if(te06==0)	
				{
					te06=1;
					tiBR06=ZADINPU;
				}
				if(tiBR06==0)BU06=0;
			}
//-------------------------------------------------------
			if(rPORTB & 0b00100000)// We test an input for low level
			{
				if(te05==1)	
				{
					te05=0;
					tiBR05=ZADINPU;
				}
				if(tiBR05==0)BU05=1;
			}
			else
			{
				if(te05==0)	
				{
					te05=1;
					tiBR05=ZADINPU;
				}
				if(tiBR05==0)BU05=0;
			}
//-------------------------------------------------------
			if(rPORTB & 0b00010000)// We test an input for low level
			{
				if(te04==1)	
				{
					te04=0;
					tiBR04=ZADINPU;
				}
				if(tiBR04==0)BU04=1;
			}
			else
			{
				if(te04==0)	
				{
					te04=1;
					tiBR04=ZADINPU;
				}
				if(tiBR04==0)BU04=0;
			}
//-------------------------------------------------------
// Testing of buttons of the keypad
			if(!(rPORTB & 0b00001000))// We test an input for low level
			{
				if(te03==1)	
				{
					te03=0;
					tiBR03=ZADKLAV;
				}
				if(tiBR03==0)BU03=1;
			}
			else
			{
				te03=1;
				BU03=0;
			}
//-------------------------------------------------------
			if(!(rPORTB & 0b00000100))// We test an input for low level
			{
				if(te02==1)	
				{
					te02=0;
					tiBR02=ZADKLAV;
				}
				if(tiBR02==0)BU02=1;
			}
			else
			{
				te02=1;
				BU02=0;
			}
//-------------------------------------------------------
			if(!(rPORTB & 0b00000010))// We test an input for low level
			{
				if(te01==1)	
				{
					te01=0;
					tiBR01=ZADKLAV;
				}
				if(tiBR01==0)BU01=1;
			}
			else
			{
				te01=1;
				BU01=0;
			}
//-------------------------------------------------------
			if(!(rPORTB & 0b00000001))// We test an input for low level
			{
				if(te00==1)	
				{
					te00=0;
					tiBR00=ZADKLAV;
				}
				if(tiBR00==0)BU00=1;
			}
			else
			{
				te00=1;
				BU00=0;
			}
}//--------------------------------------------------------------------















//--------------------------------------------------------------------
// Interruptions
void interrupt my_isr(void) //
{
	T0IF=0;	// To clear an interrupt flag of timer TMR0
//----------------------------------------------
	//The period ~	488 Hz	start
	indic();		// Indication
	if (timer_avt!=0 && KLNAJ==1)--timer_avt; // We check on a zero and if not the zero is reduced a variable
//----------------------------------------------
	//Reading of a state of buttons and remote sensors
	TRISB=0xFF;			// 
	_delay(1);			// 
	rPORTB=PORTB;		// 
	TRISB=0;			// 
//----------------------------------------------
	if(--tim10gc==0)
	{
		tim10gc=49;
		// The period 10 Hertz.------------------------
//Timers of filters of handling of input signals
		if(tiBR00!=0)tiBR00--;
		if(tiBR01!=0)tiBR01--;
		if(tiBR02!=0)tiBR02--;
		if(tiBR03!=0)tiBR03--;
		if(tiBR04!=0)tiBR04--;
		if(tiBR05!=0)tiBR05--;
		if(tiBR06!=0)tiBR06--;
		if(tiBR07!=0)tiBR07--;
		//--------------------------------------
		//--------------------------------------
		if(timer_uderj!=0)timer_uderj--;//The timer button holding in a pushed state
		//--------------------------------------

		//--------end period 10 .-----------------------------
		if(--tim2gc==0)
		{
			tim2gc=5;
			// The period 2 Hertz.-------------------

			//-----  ( -------------------------
				B_MIG = !B_MIG; //  :)
				

		}//--------end period 2 Hz.-----------------------------			
	}//--------end period 10 Hz.-----------------------------	
	
}//end_interrupt----------------------------------------------------------------






//--------------------------------------------------------------------
void init(void)// Controler initialization
{
	CLRWDT();	//   

// Generator adjustment
	OSCCON	= 0b01110001; //  8 

// Adjustment of analog inputs
	ANSEL 	= 0;	//  
	ANSELH 	= 0;

// Adjustment of ports
	TRISA	= 0;
	TRISB	= 0;
	TRISC	= 0;

	PORTA	= 0;
	PORTB	= 0;
	PORTC	= 0;
			
// Adjustment of the period of interruptions of 400 Hz for this purpose we use timer TMP0.
	OPTION_REG = 0b00000011;	// . ,   0, . 1:16
//   	
	WDTCON = 0b00010111;

//Initialization of variables
//Time dividers
	tim10gc=1;
	tim2gc=1;

//*********************
//Adjustment of interruptions

	INTCON=0b10100000;		// To resolve interruptions from TMP0
}//--------------------------------------------------------------------